// NX̃wb_CN[h
// (FKCN[hĂ邩炱őv)
#include "Car.h"


// RXgN^
Car::Car(void)
{
	init();

	return;
}

/*
	ʊ֐ɕĂƁA
	̉ł̂ŕ֗
 */ 
void Car::init(void)
{
	int		i;

	body.setSize(7.0, 6.0, 20.0);
	tire.setRadius(2.0);
	tire.setDivide(2);
	driver.setRadius(2.0);
	driver.setDivide(2);

	bodyModel.setShape(&body);
	bodyModel.glMoveTo(0.0, 5.0, 0.0);
	bodyModel.setMaterial(Yellow);
	bodyModel.setParent(&carModel);


	tireModel[0].glMoveTo(-4.0, 1.0, -8.0);
	tireModel[0].glVec(1.0, 0.0, 0.0);
	tireModel[1].glMoveTo(4.0, 1.0, -8.0);
	tireModel[1].glVec(-1.0, 0.0, 0.0);
	tireModel[2].glMoveTo(-4.0, 1.0, 8.0);
	tireModel[2].glVec(1.0, 0.0, 0.0);
	tireModel[3].glMoveTo(4.0, 1.0, 8.0);
	tireModel[3].glVec(-1.0, 0.0, 0.0);

	for(i = 0; i < 4; i++) {
		tireModel[i].setShape(&tire);
		tireModel[i].setMaterial(Gray2);
		tireModel[i].setParent(&carModel);
	}

	driverModel[0].setShape(&driver);
	driverModel[1].setShape(&driver);
	driverModel[0].glMoveTo(-2.0, 10.0, 0.0);
	driverModel[1].glMoveTo(2.0, 10.0, 0.0);
	driverModel[0].setMaterial(Cream);
	driverModel[1].setMaterial(Cream);
	driverModel[0].setSmoothMode(true);
	driverModel[1].setSmoothMode(true);
	driverModel[0].setParent(&carModel);
	driverModel[1].setParent(&carModel);

	birdModel.glMoveTo(0.0, 100.0, 200.0);
	birdModel.glFocus(0.0, 5.0, 0.0);
	birdModel.glUpvec(0.0, 1.0, 0.0);
	birdModel.setParent(&carModel);

	carModel.glMoveTo(CIRCUITX, CIRCUITY, 0.0);
	carModel.glVec(0.0, -1.0, 0.0);
	carModel.glUpvec(0.0, 0.0, 1.0);

	return;
}

void Car::entryScene(fk_Scene *scene, bool viewFlag)
{
	int		i;

	scene->entryModel(&bodyModel);

	for(i = 0; i < 4; i++) {
		scene->entryModel(&tireModel[i]);
	}

	scene->entryModel(&driverModel[0]);
	if(viewFlag == true) {
		scene->entryModel(&driverModel[1]);
	} else {
		scene->entryCamera(&driverModel[1]);
	}

	return;
}

fk_Vector Car::getCarPosition(void)
{
	return carModel.getPosition();
}

fk_Model * Car::getBirdModel(void)
{
	return &birdModel;
}

void Car::forward(void)
{
	fk_Vector	carPosition, carVelocity;
	fk_Vector	Xplus(1.0, 0.0, 0.0), Xminus(-1.0, 0.0, 0.0);
	fk_Vector	Yplus(0.0, 1.0, 0.0), Yminus(0.0, -1.0, 0.0);
	double		X = CIRCUITX;
	double		Y = CIRCUITY;

	carPosition = carModel.getPosition();
	carVelocity = carModel.getVec();
	carModel.loTranslate(0.0, 0.0, -SPEED); // Oi

	// T[Lbg̊OɂłꍇA]B
	if(carPosition.x > X) {
		rotate(&carModel, carVelocity, Xplus);
	}
	if(carPosition.x < -X) {
		rotate(&carModel, carVelocity, Xminus);
	}
	if(carPosition.y > Y) {
		rotate(&carModel, carVelocity, Yplus);
	}
	if(carPosition.y < -Y) {
		rotate(&carModel, carVelocity, Yminus);
	}

	return;
}

void Car::rotate(fk_Model *model, fk_Vector velocity, fk_Vector orgVec)
{
	// velocity  orgVec ̓ϒlA܂px 90 xȓ̏ꍇ]
	if(velocity * orgVec > EPS) {
		model->loAngle(FK_PI/400.0, 0.0, 0.0);
	}
	return;
}
