#pragma once
#include <FK/FK.h>
#include "Car.h"
#include "World.h"

class TripleWindow {
private:
	Fl_Window		mainWindow;
	fk_Scene		carViewScene, buildViewScene, birdViewScene;
	fk_Window		carViewWindow;
	fk_Window		buildViewWindow;
	fk_Window		birdViewWindow;
	// wiF
	fk_Color		bgColor;
	// _p̃f
	fk_Model		buildViewModel;

public:
	TripleWindow(void);
	~TripleWindow(void);

	bool	draw(void);
	void	updateView(Car *argCar);

	void	entryCar(Car *argCar);
	void	entryWorld(World *argWorld);
};
